// autRenewals and magRenewals have been loaded
console.log(autRenewals.length);


// result = {"type":"exact","text":text};
console.log("Loading site.js");

function showPage(page) {
  console.log("Showing: " + page);
  $("#authorResults").html("");
  $("#magResults").html("");
  $(".page").hide();
  $(page).show();
}




// search through an array both for whole term and then split, individual terms
// returns an array
function searchArray(haystack, needles) {
  var hayLength = haystack.length;
  var fullTerm = needles;
  var fullTermRegex = RegExp(fullTerm, 'i');
  var sRegex = RegExp(/[\,,\.]/, 'g');
  var tmpTerm = fullTerm.replace(sRegex, " ");
  var terms = tmpTerm.split(" ");
  terms = terms.filter(Boolean);
  var tex = [];
  for (var i = 0; i < terms.length; i++) {
    tex.push(RegExp(terms[i], 'i'));
  }


  console.log("Searching through " + hayLength + " records.");

  var results = [];
  var exact = [];
  var allterms = [];
  
  for (var i = 0; i < hayLength; i++) {
    var listing = haystack[i];
    if (listing.match(fullTermRegex)) {
      // this full search term appears in the listing
      exact.push({
        'type': 'exact',
        'text': listing
      });
    } else {
      // now check if it has all terms separately
      var hasAll = true;
      for (var j = 0; j < tex.length; j++) {
        if (!listing.match(tex[j])) {
          hasAll = false;
        }
      }

      if (hasAll == true) {
        allterms.push({
          'type': 'all terms',
          'text': listing
        });
      }

    }


  }

  results = exact.concat(allterms);
  return results;
}

function displayResults(results, div, keywords) {
  
  
  var resultHTML = "";
  if(results.length == 0){
    resultHTML = "<p><em>No results.</em></p>";
  } else {
    resultHTML += "<h2>" + results.length + " possible results.</h2>";
    var resultNum = 0;
    for(var i = 0; i < results.length; i++){
      result = results[i];
      resultNum++;
      resultHTML += "<h3>" + resultNum + " - <em>" + result['type'] + "</em> match.</h3>\n";
      resultHTML += "<pre>" + result['text'] + "</pre><br>\n";
    }
    
    
  }
  $(div).html(resultHTML);
  
  $(div).mark(keywords);
}

$(document).ready(function () {
  $("#magResults").hide();
  showPage("#front");

  $(".nav").click(function (event) {
    event.preventDefault();
    console.log("Nav link clicked");

    showPage($(this).attr('href'));
  });

  /*$("#magSearchInput").on("change keyup paste", function () {
    console.log("Search the Magazine renewals...");
  });*/

  $("#magSearchGo").click(function () {
    console.log("Searching Magazine renewals");
    var search = $("#magSearchInput").val();
    if (search.length > 3) {
      var results = searchArray(magRenewals, search);
      
      var sRegex = RegExp(/,/, 'g');
      var keywords = search.replace(sRegex, " ");
      
      displayResults(results, "#magResults", keywords);

      $("#cheatSheet").hide();
      $("#magResults").show();
    } else {
      alert("Please type a little more in the search field first.");

    }

  });

  $("#magSearchNo").click(function () {
    $("#magSearchInput").val("");
    $("#magResults").hide();
    $("#cheatSheet").show();
  });

  
  $("#autSearchGo").click(function () {
    console.log("Searching Author renewals");
    var search = $("#autSearchInput").val();
    if (search.length > 3) {
      var results = searchArray(autRenewals, search);
      
      var sRegex = RegExp(/,/, 'g');
      var keywords = search.replace(sRegex, " ");
      
      displayResults(results, "#authorResults", keywords);

      
    } else {
      alert("Please type a little more in the search field first.");

    }

  });

  $("#autSearchNo").click(function () {
    $("#autSearchInput").val("");
    $("#authorResults").html("");
  });



  console.log("All loaded and initialized");
});
